<?php

namespace Teknisa\FIN\Modules\ContaReceber\Controllers;

use Teknisa\FIN\Controllers\TeknisaCrud;
use Teknisa\FIN\Modules\ContaReceber\Services\Rec41100TipoCtReceberService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;



class TipoctreceberClassfinancContctbl extends TeknisaCrud{

  protected $dataSourceName = 'tipoctreceber_classfinanc_contctbl';
  
  protected $parameterBag;
  protected $crudService;
  protected $service;
  
  public function __construct($crudService, ParameterBag $parameterBag, Rec41100TipoCtReceberService $service) {
    $this->service = $service;
    parent::__construct($crudService, $parameterBag);
  }
  
  public function save(DTO\Request $request, DTO\Response $response) {
    $this->dataSourceName = 'tipoctreceber_classfinanc_contctbl';
    $row = $request->getDataSet()->getRows()[0];
    
    if(!isset($row['CDHISTPADR'])) {
      $row['CDHISTPADR'] = null;
      $newDataSet = new DataSet($this->dataSourceName, array($row));
      $newRequest = new DTO\Request\DataSet($newDataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
      parent::save($newRequest, $response);
    } else {
      parent::save($request, $response);
    }
  }
  
  public function getNvMaxContctbl(DTO\Request $request, DTO\Response $response) {
    
    $result = $this->service->getNvMaxContctbl();
    $dataSet = new DataSet('paramgeral', $result);
    $response->addDataSet($dataSet); 
    
  }
  
  
}